# WARNING: Please don't edit this file. It was generated by Python/WinRT v3.2.1

import datetime
import sys
import types
import typing
import uuid as _uuid
from builtins import property as _property

import winrt._winrt
import winrt.system
import winrt.windows.devices.geolocation as windows_devices_geolocation
import winrt.windows.foundation as windows_foundation
import winrt.windows.foundation.collections as windows_foundation_collections

from winrt.windows.devices.geolocation.geofencing import GeofenceMonitorStatus, GeofenceRemovalReason, GeofenceState, MonitoredGeofenceStates

Self = typing.TypeVar('Self')

@typing.final
class Geofence(winrt.system.Object):
    @typing.overload
    def __new__(cls: typing.Type[Self], id: str, geoshape: windows_devices_geolocation.IGeoshape) -> Self: ...
    @typing.overload
    def __new__(cls: typing.Type[Self], id: str, geoshape: windows_devices_geolocation.IGeoshape, monitored_states: MonitoredGeofenceStates, single_use: bool) -> Self: ...
    @typing.overload
    def __new__(cls: typing.Type[Self], id: str, geoshape: windows_devices_geolocation.IGeoshape, monitored_states: MonitoredGeofenceStates, single_use: bool, dwell_time: datetime.timedelta) -> Self: ...
    @typing.overload
    def __new__(cls: typing.Type[Self], id: str, geoshape: windows_devices_geolocation.IGeoshape, monitored_states: MonitoredGeofenceStates, single_use: bool, dwell_time: datetime.timedelta, start_time: datetime.datetime, duration: datetime.timedelta) -> Self: ...
    # Windows.Foundation.TimeSpan Windows.Devices.Geolocation.Geofencing.Geofence::get_Duration()
    @_property
    def duration(self) -> datetime.timedelta: ...
    # Windows.Foundation.TimeSpan Windows.Devices.Geolocation.Geofencing.Geofence::get_DwellTime()
    @_property
    def dwell_time(self) -> datetime.timedelta: ...
    # Windows.Devices.Geolocation.IGeoshape Windows.Devices.Geolocation.Geofencing.Geofence::get_Geoshape()
    @_property
    def geoshape(self) -> windows_devices_geolocation.IGeoshape: ...
    # System.String Windows.Devices.Geolocation.Geofencing.Geofence::get_Id()
    @_property
    def id(self) -> str: ...
    # Windows.Devices.Geolocation.Geofencing.MonitoredGeofenceStates Windows.Devices.Geolocation.Geofencing.Geofence::get_MonitoredStates()
    @_property
    def monitored_states(self) -> MonitoredGeofenceStates: ...
    # System.Boolean Windows.Devices.Geolocation.Geofencing.Geofence::get_SingleUse()
    @_property
    def single_use(self) -> bool: ...
    # Windows.Foundation.DateTime Windows.Devices.Geolocation.Geofencing.Geofence::get_StartTime()
    @_property
    def start_time(self) -> datetime.datetime: ...

@typing.final
class GeofenceMonitor_Static(winrt._winrt.IInspectable_Static):
    # Windows.Devices.Geolocation.Geofencing.GeofenceMonitor Windows.Devices.Geolocation.Geofencing.GeofenceMonitor::get_Current()
    @_property
    def current(cls) -> GeofenceMonitor: ...

@typing.final
class GeofenceMonitor(winrt.system.Object, metaclass=GeofenceMonitor_Static):
    # Windows.Foundation.Collections.IVectorView`1<Windows.Devices.Geolocation.Geofencing.GeofenceStateChangeReport> Windows.Devices.Geolocation.Geofencing.GeofenceMonitor::ReadReports()
    def read_reports(self) -> typing.Sequence[GeofenceStateChangeReport]: ...
    # Windows.Foundation.EventRegistrationToken Windows.Devices.Geolocation.Geofencing.GeofenceMonitor::add_GeofenceStateChanged(Windows.Foundation.TypedEventHandler`2<Windows.Devices.Geolocation.Geofencing.GeofenceMonitor,System.Object>)
    def add_geofence_state_changed(self, event_handler: windows_foundation.TypedEventHandler[GeofenceMonitor, winrt.system.Object], /) -> windows_foundation.EventRegistrationToken: ...
    # System.Void Windows.Devices.Geolocation.Geofencing.GeofenceMonitor::remove_GeofenceStateChanged(Windows.Foundation.EventRegistrationToken)
    def remove_geofence_state_changed(self, token: typing.Union[windows_foundation.EventRegistrationToken, typing.Tuple[winrt.system.Int64]], /) -> None: ...
    # Windows.Foundation.EventRegistrationToken Windows.Devices.Geolocation.Geofencing.GeofenceMonitor::add_StatusChanged(Windows.Foundation.TypedEventHandler`2<Windows.Devices.Geolocation.Geofencing.GeofenceMonitor,System.Object>)
    def add_status_changed(self, event_handler: windows_foundation.TypedEventHandler[GeofenceMonitor, winrt.system.Object], /) -> windows_foundation.EventRegistrationToken: ...
    # System.Void Windows.Devices.Geolocation.Geofencing.GeofenceMonitor::remove_StatusChanged(Windows.Foundation.EventRegistrationToken)
    def remove_status_changed(self, token: typing.Union[windows_foundation.EventRegistrationToken, typing.Tuple[winrt.system.Int64]], /) -> None: ...
    # Windows.Foundation.Collections.IVector`1<Windows.Devices.Geolocation.Geofencing.Geofence> Windows.Devices.Geolocation.Geofencing.GeofenceMonitor::get_Geofences()
    @_property
    def geofences(self) -> typing.MutableSequence[Geofence]: ...
    # Windows.Devices.Geolocation.Geoposition Windows.Devices.Geolocation.Geofencing.GeofenceMonitor::get_LastKnownGeoposition()
    @_property
    def last_known_geoposition(self) -> windows_devices_geolocation.Geoposition: ...
    # Windows.Devices.Geolocation.Geofencing.GeofenceMonitorStatus Windows.Devices.Geolocation.Geofencing.GeofenceMonitor::get_Status()
    @_property
    def status(self) -> GeofenceMonitorStatus: ...

@typing.final
class GeofenceStateChangeReport(winrt.system.Object):
    # Windows.Devices.Geolocation.Geofencing.Geofence Windows.Devices.Geolocation.Geofencing.GeofenceStateChangeReport::get_Geofence()
    @_property
    def geofence(self) -> Geofence: ...
    # Windows.Devices.Geolocation.Geoposition Windows.Devices.Geolocation.Geofencing.GeofenceStateChangeReport::get_Geoposition()
    @_property
    def geoposition(self) -> windows_devices_geolocation.Geoposition: ...
    # Windows.Devices.Geolocation.Geofencing.GeofenceState Windows.Devices.Geolocation.Geofencing.GeofenceStateChangeReport::get_NewState()
    @_property
    def new_state(self) -> GeofenceState: ...
    # Windows.Devices.Geolocation.Geofencing.GeofenceRemovalReason Windows.Devices.Geolocation.Geofencing.GeofenceStateChangeReport::get_RemovalReason()
    @_property
    def removal_reason(self) -> GeofenceRemovalReason: ...

